/*
create database CLAVERO_VINOS

use CLAVERO_VINOS

create table COMUNIDAD
(
ComunidadID char(2),
Comunidad varchar(20)
constraint PK_COMUNIDAD Primary Key(ComunidadID)
)

create table PROVINCIAS
(
ProvinciaID char(2),
ComunidadID char(2),
Provincia varchar(20),
Poblacion integer,
constraint PK_PROVINCIAS Primary Key(ProvinciaID),
constraint FK_PROVINCIASCOMUNIDAD Foreign Key(ComunidadID)references COMUNIDAD
)
create table CAJAS
(
CajaID char(1),
Descripcion varchar(50),
Precio integer
constraint PK_CAJAS Primary Key(CajaID)
)
create table BODEGAS
(
BodegaID char(2),
Nombre varchar(50),
Email varchar(50),
Tfno1 varchar(50),
Tfno2 varchar(50),
constraint PK_BODEGAS Primary Key(BodegaID)
)
create table VINOS
(
VinoID char(1),
Nombre varchar(50),
Denom_Or varchar(50),
Categoria varchar(50),
Uva varchar(50),
Aada varchar(20),
Cata varchar(20),
Temperatura varchar(20),
Comentario varchar(30),
BodegaID char(2),
constraint PK_VINOS Primary Key(VinoID),
constraint FK_VINOSBODEGAS Foreign Key(BodegaID)references BODEGAS
)
create table PRODUCTOS
(
ProductID char(2),
VinoID char(1),
Descripcion varchar(50),
Precio integer,
Unidades integer,
constraint PK_PRODUCTOS Primary Key(ProductID),
constraint FK_PRODUCTOSVINOS Foreign Key(VinoID)references VINOS
)
create table CLIENTES
(
ClienteID char(10),
Tipo char(1),
Nombre varchar(50),
Domicilio varchar(50),
Localidad varchar(50),
ProvinciaID char(2),
CodPostal varchar(6),
Email varchar(50),
Tfno1 varchar(50),
Tfno2 varchar(50),
Fechana varchar(50),
Usuario varchar(50),
Clave varchar(50),
constraint PK_CLIENTES Primary Key(ClienteID),
constraint FK_CLIENTESPROVINCIAS Foreign Key(ProvinciaID)references PROVINCIAS
)
create table PEDIDOS
(
Num integer identity Not Null,
Fecha varchar(50),
Caja integer,
CajaID char(1),
ClienteID char(10),
Regalo integer,
Nombre_Envio varchar(50),
Direccion_Envio varchar(50),
Localidad_Envio varchar(50),
Provincia_Envio varchar(50),
CodPostal_Envio varchar(50),
constraint PK_PEDIDOS Primary Key(Num),
constraint FK_PEDIDOSCAJAS Foreign Key(CajaID)references CAJAS,
constraint FK_PEDIDOSCLIENTES Foreign Key(ClienteID)references CLIENTES
)
create table DETALLES
(
Num integer,
ProductID char(2),
Unidades integer,
Precio integer,
constraint PK_DETALLES Primary Key(Num, ProductID),
constraint FK_DETALLESPEDIDOS Foreign Key(Num)references PEDIDOS,
constraint FK_DETALLESPRODUCTOS Foreign Key(ProductID)references PRODUCTOS
)



INSERT INTO COMUNIDAD VALUES ('AN','Andaluca')
INSERT INTO COMUNIDAD VALUES ('GA','Galicia')
INSERT INTO COMUNIDAD VALUES ('MA', 'Madrid')
INSERT INTO COMUNIDAD VALUES ('AR', 'Aragn')

INSERT INTO PROVINCIAS VALUES ('28', 'MA', 'Madrid', 4000000)
INSERT INTO PROVINCIAS VALUES ('04', 'AN', 'Almera', 400000)
INSERT INTO PROVINCIAS VALUES ('11', 'AN', 'Cdiz', 1000000)
INSERT INTO PROVINCIAS VALUES ('14', 'AN', 'Crdoba', 500000)
INSERT INTO PROVINCIAS VALUES ('15', 'GA', 'La Corua', 1200000)
INSERT INTO PROVINCIAS VALUES ('18', 'AN', 'Granada', 700000)
INSERT INTO PROVINCIAS VALUES ('21', 'AN', 'Huelva', 550000)
INSERT INTO PROVINCIAS VALUES ('23', 'AN', 'Jan', 300000)
INSERT INTO PROVINCIAS VALUES ('27', 'GA', 'Lugo', 415000)
INSERT INTO PROVINCIAS VALUES ('29', 'AN', 'Mlaga', 1100000)
INSERT INTO PROVINCIAS VALUES ('32', 'GA', 'Orense', 150000)
INSERT INTO PROVINCIAS VALUES ('36', 'GA', 'Pontevedra', 400000)
INSERT INTO PROVINCIAS VALUES ('41', 'AN', 'Sevilla', 1500000)
INSERT INTO PROVINCIAS VALUES ('50','AR', 'Zaragoza', 850000)

INSERT INTO CAJAS VALUES ('a','Caja de una botella',8)
INSERT INTO CAJAS VALUES ('b','Caja de 2 botellas',8)
INSERT INTO CAJAS VALUES ('c','Caja de 3 botellas',9)
INSERT INTO CAJAS VALUES ('d','Caja de 4 botellas',10)
INSERT INTO CAJAS VALUES ('e','Caja de 6 botellas',12)

INSERT INTO CLIENTES VALUES ('11237854','P','Luisa Martnez',null,'Sevilla','41',null,null,null,null,null,NULL,NULL)
INSERT INTO CLIENTES VALUES ('11786712','P','Ana Garca',null,'Andjar','23',null,nulL,null,null,null,null,null)
INSERT INTO CLIENTES VALUES ('12355122','P','Alberto Fernndez',null,'La Corua','15',null,nulL,null,null,null,null,null)
INSERT INTO CLIENTES VALUES ('16678122','P','Luis Gmez',null,'Madrid','28',null,nulL,null,null,null,null,null)
INSERT INTO CLIENTES VALUES ('23715431','P','Ramn Garca',null,'Sevilla','41',null,nulL,null,null,null,null,null)
INSERT INTO CLIENTES VALUES ('55252181','P','Cosme Gutirrez',null,'Huelva','21',null,null,null,null,null,null,null)
INSERT INTO CLIENTES VALUES ('67711112','P','Antonio Jos Lpez',null,'Madrid','28',null,null,null,null,null,null,null)
INSERT INTO CLIENTES VALUES ('78378765','P','Laura Lpez',null,'Roquetas de Mar','04',null,null,null,null,null,null,null)
INSERT INTO CLIENTES VALUES ('B28560482','E','CMA',null,'Madrid','28',null,null,null,null,null,null,null)
INSERT INTO CLIENTES VALUES ('B50130635','E','Acme, SA',null,'Zaragoza','50',null,null,null,null,null,null,null)

INSERT INTO BODEGAS VALUES ('P1','Enate','bodega@enate.es','974302550','974300046')
INSERT INTO BODEGAS VALUES ('P2','Vias del Vero','info@vinasdelvero.es',null,null)
INSERT INTO BODEGAS VALUES ('P3','Bodegas y Viedos del Jaln','info@castillomaluenda.com','976889251','976889252')
INSERT INTO BODEGAS VALUES ('P4','Bodegas Ayles','info@bodegasayles.com','976140473',null)

INSERT INTO VINOS VALUES ('1','Enate Crianza','Somontano','Crianza','Tempranillo-cabernet sauvignon','2004','Equilibrada','16-18',null,'P1')
INSERT INTO VINOS VALUES ('2','Enate Reserva','Somontano','Reserva','Cabernet sauvignon','2003','Estructurado','16-18',null,'P1')
INSERT INTO VINOS VALUES ('3','Vias del Vero','Somontano','Blanco','Chardonay','2005','Elegante','10-12',null,'P2')
INSERT INTO VINOS VALUES ('4','Castillo de Maluenda','Calatayud','Reserva','Cabernet sauvignon','1999','Estructurado','16-18',null,'P3')
INSERT INTO VINOS VALUES ('5','Ayles','Cariena','Joven','Garnacha-Merlot','2005','Expresivo','15',null,'P4')

INSERT INTO PRODUCTOS VALUES ('B1','1','Botella 3/4',10,250)
INSERT INTO PRODUCTOS VALUES ('10','4','Botella 3/4',7,90)
INSERT INTO PRODUCTOS VALUES ('11','4','Caja de 6 Botellas 3/4',42,50)
INSERT INTO PRODUCTOS VALUES ('12','5','Botella 3/4',5,60)
INSERT INTO PRODUCTOS VALUES ('13','5','Caja de 4 Botella 3/4',20,20)
INSERT INTO PRODUCTOS VALUES ('14','5','Caja de 6 Botellas 3/4',30,15)
INSERT INTO PRODUCTOS VALUES ('B2','1','Botella Magnum',18,75)
INSERT INTO PRODUCTOS VALUES ('B3','1','Caja de 6 botellas 3/4',60,180)
INSERT INTO PRODUCTOS VALUES ('B4','2','Botella 3/4',18,200)
INSERT INTO PRODUCTOS VALUES ('B5','2','Caja de 4 Botellas',72,50)
INSERT INTO PRODUCTOS VALUES ('B6','3','Botella 3/4',7,190)
INSERT INTO PRODUCTOS VALUES ('B7','3','Caja de 3 Botellas 3/4',21,150)
INSERT INTO PRODUCTOS VALUES ('B8','3','Caja de 6 Botellas 3/4',42,30)
INSERT INTO PRODUCTOS VALUES ('B9','4','Botella Magnum',11,15)

INSERT INTO PEDIDOS VALUES ('10/10/2006',1,'a','23715431',0,null,null,null,null,null)
INSERT INTO PEDIDOS VALUES ('4/11/2006 0:00:00',0,null,'23715431',0,null,null,null,null,null)
INSERT INTO PEDIDOS VALUES ('10/10/2006 0:00:00',1,'a','23715431',0,null,null,null,null,null)
INSERT INTO PEDIDOS VALUES ('6/11/2006 0:00:00',0,null,'16678122',1,'Luis Prez','Pza. Espaa, 2','Sevilla','41001','41')
INSERT INTO PEDIDOS VALUES ('17/10/2006 0:00:00',1,'d','78378765',0,null,null,null,null,null)
INSERT INTO PEDIDOS VALUES ('2/11/2006 0:00:00',1,'c','23715431',0,null,null,null,null,null)
INSERT INTO PEDIDOS VALUES ('20/10/2006 0:00:00',1,'c','67711112',1,'Antonia Ruiz','Cnovas 12','Calatayud','50080','50')
INSERT INTO PEDIDOS VALUES ('15/10/2006 0:00:00',0,null,'12355122',0,null,null,null,null,null)
INSERT INTO PEDIDOS VALUES ('9/10/2006 0:00:00',0,null,'11786712',0,null,null,null,null,null)
INSERT INTO PEDIDOS VALUES ('16/10/2006 0:00:00',1,'e','B28560482',1,'Carlos Fernndez','Picasso 12','Ferrol','15025','15')

INSERT INTO DETALLES  VALUES (3,'B1',1,10)
INSERT INTO DETALLES  VALUES (4,'B2',2,18)
INSERT INTO DETALLES  VALUES (4,'B3',1,60)
INSERT INTO DETALLES  VALUES (5,'12',2,5)
INSERT INTO DETALLES  VALUES (5,'B6',2,7)
INSERT INTO DETALLES  VALUES (6,'B4',2,18)
INSERT INTO DETALLES  VALUES (7,'B1',1,10)
INSERT INTO DETALLES  VALUES (7,'12',1,5)
INSERT INTO DETALLES  VALUES (7,'B6',1,7)
INSERT INTO DETALLES  VALUES (8,'11',1,42)
INSERT INTO DETALLES  VALUES (8,'B5',1,72)
INSERT INTO DETALLES  VALUES (9,'B9',5,11)
INSERT INTO DETALLES  VALUES (10,'B1',2,10)
INSERT INTO DETALLES  VALUES (10,'12',1,5)
INSERT INTO DETALLES  VALUES (10,'B4',3,18)


--CONSULTA N 1 Poblacin por cada Comunidad Autnoma.
select COMUNIDAD.Comunidad,sum(Poblacion)
from PROVINCIAS,COMUNIDAD
where PROVINCIAS.ComunidadID=COMUNIDAD.ComunidadID
group by COMUNIDAD.Comunidad



--CONSULTA N 2 Poblacin por cada Comunidad Autnoma.
select top 1 Provincia,Poblacion
from PROVINCIAS
order by Poblacion desc


--CONSULTA N3 Provincia con volumen de poblacin comprendida entre 100.000 y +100.000
--habitantes sobre la poblacin media.
select Provincia, Poblacion
from PROVINCIAS
where Poblacion between 
		(select AVG(Poblacion)-100000 
		from PROVINCIAS)
		and
		(select AVG(Poblacion)+100000 
		from PROVINCIAS)
		
		

--CONSULTA N4 Nmero de clientes en las provincias con ms de 500.000 habitantes sobre la
--poblacin media.
select PROVINCIAS.Provincia,COUNT(ClienteID)
from CLIENTES,PROVINCIAS
where CLIENTES.ProvinciaID=PROVINCIAS.ProvinciaID
and PROVINCIAS.Poblacion >
(select AVG(Poblacion)+500000 from PROVINCIAS)
group by PROVINCIAS.Provincia



--CONSULTA N5 Cul es el nombre de la bodega de la que ms unidades vendemos?.
select top 1 BODEGAS.Nombre, SUM(DETALLES.Unidades)
from BODEGAS,VINOS,PRODUCTOS,DETALLES
where BODEGAS.BodegaID=VINOS.BodegaID 
	  and VINOS.VinoID=PRODUCTOS.VinoID
	  and PRODUCTOS.ProductID=DETALLES.ProductID
group by BODEGAS.Nombre
order by SUM(DETALLES.Unidades) desc


--CONSULTA N6 Relacin de vinos vendidos en cajas de madera, ordenados por orden alfabtico
--del nombre del cliente; si el pedido es para regalo debe poner Para regalo.
select CLIENTES.Nombre,VINOS.Nombre,case when PEDIDOS.Regalo=0 then 'No Regalo' else 'Para Regalo' end as 'Regalo'
from CLIENTES,PEDIDOS,DETALLES,PRODUCTOS,VINOS
where VINOS.VinoID=PRODUCTOS.VinoID
	  and PRODUCTOS.ProductID=DETALLES.ProductID
	  and DETALLES.Num=PEDIDOS.Num
	  and CLIENTES.ClienteID=PEDIDOS.ClienteID 
	  and PEDIDOS.Caja=1
group by CLIENTES.Nombre,VINOS.Nombre,PEDIDOS.Regalo


--CONSULTA N7 Nmero de pedidos servidos de cada denominacin de origen por Comunidad Autnoma.
select COMUNIDAD.Comunidad,VINOS.Denom_Or,SUM(DETALLES.Unidades)
from VINOS,PRODUCTOS,DETALLES,PEDIDOS,CLIENTES,PROVINCIAS,COMUNIDAD
where VINOS.VinoID=PRODUCTOS.VinoID
	  and PRODUCTOS.ProductID=DETALLES.ProductID
	  and DETALLES.Num=PEDIDOS.Num
	  and PEDIDOS.ClienteID=CLIENTES.ClienteID
	  and CLIENTES.ProvinciaID=PROVINCIAS.ProvinciaID
	  and PROVINCIAS.ComunidadID=COMUNIDAD.ComunidadID
group by VINOS.Denom_Or,COMUNIDAD.Comunidad



--CONSULTA N8 Relacin valorada del detalle de cada pedido, ordenada por nmero de pedido.
select PEDIDOS.*,DETALLES.Precio
from PEDIDOS,DETALLES
where PEDIDOS.Num=DETALLES.Num
order by PEDIDOS.Num


--CONSULTA N9 Valoracin global de cada pedido, Debe indicarse la fecha, el cliente., si es o no
--para regalo, y la Comunidad Autnoma del cliente. Ordenar por importe del.
--pedido
select CLIENTES.Nombre,PEDIDOS.Fecha,PEDIDOS.Regalo,COMUNIDAD.Comunidad,SUM(DETALLES.Unidades*DETALLES.Precio) as Importe
from PRODUCTOS,DETALLES,PEDIDOS,CLIENTES,PROVINCIAS,COMUNIDAD
where PRODUCTOS.ProductID=DETALLES.ProductID
	  and DETALLES.Num=PEDIDOS.Num
	  and PEDIDOS.ClienteID=CLIENTES.ClienteID
	  and CLIENTES.ProvinciaID=PROVINCIAS.ProvinciaID
	  and PROVINCIAS.ComunidadID=COMUNIDAD.ComunidadID
group by CLIENTES.Nombre,PEDIDOS.Fecha,PEDIDOS.Regalo,COMUNIDAD.Comunidad
order by Importe desc


--CONSULTA N10 Total de facturacin por bodega en pedidos servidos en caja de madera.
select BODEGAS.Nombre,SUM(DETALLES.Unidades*DETALLES.Precio) as Facturado
from BODEGAS,VINOS,PRODUCTOS,DETALLES,PEDIDOS
where BODEGAS.BodegaID=VINOS.BodegaID
	  and VINOS.VinoID=PRODUCTOS.VinoID
	  and PRODUCTOS.ProductID=DETALLES.ProductID
	  and DETALLES.Num=PEDIDOS.Num
	  and PEDIDOS.Caja=1
group by BODEGAS.Nombre
order by Facturado desc


--CONSULTA N11 Tasa de gasto por provincia.
select PROVINCIAS.Provincia,SUM(DETALLES.Unidades*DETALLES.Precio) as Total_Gastado
from DETALLES,PEDIDOS,CLIENTES,PROVINCIAS
where DETALLES.Num=PEDIDOS.Num
	  and PEDIDOS.ClienteID=CLIENTES.ClienteID
	  and CLIENTES.ProvinciaID=PROVINCIAS.ProvinciaID
group by PROVINCIAS.Provincia
order by Total_Gastado desc
/*

